--
-- Copyright (C) 1998  Jim Bean
-- All rights reserved.
--
-- This software may be freely copied, modified, and redistributed
-- provided that this copyright notice is preserved on all copies.
--
-- You may not distribute this software, in whole or in part, as part of
-- any commercial product without the express consent of the authors.
--
-- There is no warranty or other guarantee of fitness of this software
-- for any purpose.  It is provided solely "as is".
--
--

-- adclib.ads

package ADC_lib is

type WORD is range 0..65535;
for WORD'Size use 16; -- bits

type Int_Array   is array (Integer range <>) of Integer;
type Word_Array  is array (Integer range <>) of WORD;
type Float_Array is array (Integer range <>) of Float;

procedure Convert_Data (Num_Points: in Long_Integer;
                        AD_Data   : in Word_Array;
                        Chan_Tags : out Int_Array);
pragma Import (C, Convert_Data, "ConvertData");

-------------------------------------------------------------------

procedure Raw_To_Real  (Num_Points: in Long_Integer;
                        Raw_Data  : in Word_Array;
                        Real_Data : out Float_Array);
pragma Import (C, Raw_To_Real, "RawToReal");

-------------------------------------------------------------------

function  adcopen_1401_12 (Mode, Freq, Gain_Sel,
                           Ch, DMALen: in Integer) return Integer;
pragma Import (C, Adcopen_1401_12, "adcopen_1401_12");

-------------------------------------------------------------------

function  adcopen_1402_12 (Mode, Freq, Gain_Sel,
                           Ch, DMALen: in Integer) return Integer;
pragma Import (C, Adcopen_1402_12, "adcopen_1402_12");

-------------------------------------------------------------------

function  adcopen_1402_16 (Mode, Freq, Gain_Sel,
                           Ch, DMALen: in Integer) return Integer;
pragma Import (C, Adcopen_1402_16, "adcopen_1402_16");

-------------------------------------------------------------------

function  ADC_Read (Fd: Integer; Buf: Word_Array;
                   Datasets: Integer) return Integer;
pragma Import (C, ADC_Read, "adcread");

-------------------------------------------------------------------

function  DIO_Read (Fd: Integer) return Integer;
pragma Import (C, DIO_Read, "DIOread");

-------------------------------------------------------------------

procedure DIO_Write (Fd: in Integer; Value: in Integer);
pragma Import (C, DIO_Write, "DIOwrite");

-------------------------------------------------------------------

procedure ADC_Close (Fd: in Integer);
pragma Import (C, ADC_Close, "adclose");

end ADC_lib;
